import 'dart:io';

import './pojo/image_doc_header.dart';
import './pojo/image_nt_header.dart';
import './pojo/image_section_header.dart';
import './pojo/resourse_section.dart';
import './pojo/reader_seeker.dart';

class PeFile {
  ImageDocHeader? imageDocHeader;
  ImageNtHeaders32? imageNtHeaders;
  List<ImageSectionHeader> imageSectionHeaders = [];
  IMAGE_RESOURCE_DIRECTORY? imageResourceDirectory;

  PeFile.parseFile(String filepath) {
    File file = File(filepath);
    var data = ReaderSeeker(file.readAsBytesSync());
    imageDocHeader = ImageDocHeader(data);
    data.seek(imageDocHeader!.elfanew);
    imageNtHeaders = ImageNtHeaders32(data);
    imageSectionHeaders = <ImageSectionHeader>[];
    for (var i = 0; i < imageNtHeaders!.fileHeader.numberOfSections; i++) {
      imageSectionHeaders.add(ImageSectionHeader(data));
    }
    var resourse_section =
        imageSectionHeaders.firstWhere((element) => element.name == '.rsrc');
    imageResourceDirectory = IMAGE_RESOURCE_DIRECTORY(
        resourse_section.pointerToRawData, 0, resourse_section, data);
  }

  @override
  String toString() {
    return '{"imageDocHeader":${imageDocHeader.toString()}, "imageNtHeaders":${imageNtHeaders.toString()}, "imageSectionHeaders":${imageSectionHeaders.toString()}, "imageResourceDirectory":${imageResourceDirectory.toString()}}';
  }
}
