import 'dart:typed_data';
import './reader_seeker.dart';

class ImageDocHeader {
  
   int emagic = 0;
  int ecblp = 0;
  int ecp = 0;
  int ecrlc = 0;
  int ecparhdr =0;
  int eminalloc = 0;
  int emaxalloc = 0;
  int ess = 0;
  int esp = 0;
  int ecsum = 0;
  int eip = 0;
  int ecs = 0;
  int elfarlc = 0;
  int eovno = 0;
  int eres = 0;
  int eoemid = 0;
  int eoeminfo = 0;
  Uint8List eres2 = Uint8List(20);
  int elfanew = 0;

  ImageDocHeader(ReaderSeeker reader){
    var buffer = reader.getData(64);
    emagic = buffer.getUint16(0,Endian.little);
    ecblp = buffer.getUint16(2,Endian.little);
    ecp = buffer.getUint16(4,Endian.little);
    ecrlc = buffer.getUint16(6,Endian.little);
    ecparhdr = buffer.getUint16(8,Endian.little);
    eminalloc = buffer.getUint16(10,Endian.little);
    emaxalloc = buffer.getUint16(12,Endian.little);
    ess = buffer.getUint16(14,Endian.little);
    esp = buffer.getUint16(16,Endian.little);
    ecsum = buffer.getUint16(18,Endian.little);
    eip = buffer.getUint16(20,Endian.little);
    ecs = buffer.getUint16(22,Endian.little);
    elfarlc = buffer.getUint16(24,Endian.little);
    eovno = buffer.getUint16(26,Endian.little);
    eres = buffer.getUint64(28,Endian.little);
    eoemid = buffer.getUint16(36,Endian.little);
    eoeminfo = buffer.getUint16(38,Endian.little);
    eres2 = buffer.buffer.asUint8List(40,20);
    elfanew = buffer.getUint32(60,Endian.little);
  }

  @override
  String toString(){
    return '{"emagic":{${emagic.toRadixString(16)}, "ecblp":${ecblp.toRadixString(16)}, "ecp":${ecp.toRadixString(16)}, "ecrlc":${ecrlc.toRadixString(16)}, "ecparhdr":${ecparhdr.toRadixString(16)}, "eminalloc":${eminalloc.toRadixString(16)}, "emaxalloc":${emaxalloc.toRadixString(16)}, "ess":${ess.toRadixString(16)}, "esp":${esp.toRadixString(16)}, "ecsum":${ecsum.toRadixString(16)}, "eip":${eip.toRadixString(16)}, "ecs":${ecs.toRadixString(16)}, "elfarlc":${elfarlc.toRadixString(16)}, "eovno":${eovno.toRadixString(16)}, "eres":${eres.toRadixString(16)}, "eoemid":${eoemid.toRadixString(16)}, "eoeminfo":${eoeminfo.toRadixString(16)}, "eres2":${eres2.toString()}, "elfanew":${elfanew.toString()}}';
  }
}